Attribute VB_Name = "OGLModule"
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'  Ce module contient des codes VB6 OpenGL pour l'initialisation, la texture , la lumire              '
'                   CopyRight  2004 cuq                                                     '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Option Explicit

'Declarations...

Global hglRC1 As Long, hglRC2 As Long 'Rendering context handles
Global hDC1 As Long, hDC2 As Long     'HDC's of viewports


'Variables pour la lumire...
Dim Amb_Dif_Light(3) As Single '= { 0.5!, 0.5!, 0.5!, 1.0! } 'Lumire ambient diffuse
Dim SpecularLight(3) As Single '= { 1.0!, 1.0!, 1.0!, 1.0! } ' specular light
Dim Light1Pos!(3) 'la lumire qui claire la scne


Public Selected As Byte     'Identifie  objet qui est sous le pointeur de la souris

' Fonction d'initialisation OpenGL
Function InitGL() As Boolean
Dim Pfd As PIXELFORMATDESCRIPTOR
Dim Result As Long
Dim MaCouleur As CouleurRVB

  'Setup PDF n RC ...
  Pfd.nSize = Len(Pfd)
  Pfd.nVersion = 1
  Pfd.dwFlags = PFD_SUPPORT_OPENGL Or PFD_DRAW_TO_WINDOW Or PFD_DOUBLEBUFFER Or PFD_TYPE_RGBA
  Pfd.iPixelType = PFD_TYPE_RGBA
  Pfd.cColorBits = 32
  Pfd.cDepthBits = 16
 
 
  Result = ChoosePixelFormat(hDC1, Pfd)
  If Result = 0 Then
      MsgBox "OpenGL Initialization Failed!", vbCritical
      InitGL = False
      Exit Function
  End If
  SetPixelFormat hDC1, Result, Pfd
  hglRC1 = wglCreateContext(hDC1)
  
  'Init variable OpenGL ...
  Amb_Dif_Light(0) = 0.5!
  Amb_Dif_Light(1) = 0.5!
  Amb_Dif_Light(2) = 0.5!
  Amb_Dif_Light(3) = 1!
  
  SpecularLight(0) = 1!
  SpecularLight(1) = 1!
  SpecularLight(2) = 1!
  SpecularLight(3) = 1!
  
  
  'lumire 1
  Light1Pos(0) = 0!
  Light1Pos(1) = 0!
  Light1Pos(2) = -20!
  Light1Pos(3) = 1!
  


  
  'ViewPort 1 Specific inits...
  wglMakeCurrent hDC1, hglRC1
  glClearColor 0, 0, 0, 0  ' Couleur du fond de la scene OpenGL
  glShadeModel (GL_SMOOTH) 'Lissage des ombrages
  glEnable GL_CULL_FACE    'Pas de calcul de l'intrieur des faces
  glFrontFace GL_CCW
  glEnable GL_DEPTH_TEST
  glClearDepth 1
  glDepthFunc cfLEqual
  glBlendFunc GL_SRC_ALPHA, GL_DST_ALPHA
  glEnable GL_COLOR_MATERIAL
  
  glEnable GL_LIGHTING    'Active la lumire
  

  'Setup Light1, cette lumire claire la scne
  glLightfv GL_LIGHT1, GL_AMBIENT, Amb_Dif_Light(0)
  glLightfv GL_LIGHT1, GL_DIFFUSE, Amb_Dif_Light(0)
  glLightfv GL_LIGHT1, GL_SPECULAR, SpecularLight(0)
  glLightfv GL_LIGHT1, GL_POSITION, Light1Pos(0)    'Place la lumire devant le cube
  
  'Materials r Specular...
  glMaterialfv GL_FRONT, GL_SPECULAR, SpecularLight(0)
  glMaterialf GL_FRONT, GL_SHININESS, 1!
  
  'Active lumire 1
  glEnable GL_LIGHT1

 'Indispensable  la cration du texte
 ' Il faut crer en premier la Police de caractre
 MaCouleur.Rouge = 0.7
 MaCouleur.Vert = 0.5
 MaCouleur.Bleu = 0.1
  Create3dFont hDC1, ARIAL36, "Arial", 36, FW_BOLD, 0, MaCouleur

  InitGL = True
End Function





